=begin

    Copyright The Resistance (C) 1995-2011

    Author: blass
    blass[at]sdf.lonestar.org

    Badass 0.1 alpha

    This file is part of Badass.

    Badass is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Badass is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Badass.  If not, see <http://www.gnu.org/licenses/>.

=end

module Racket
  module L5
    # Network time protocol
    class NTP < RacketPart
      # Leap Indicator
      unsigned :leap, 2
      # Local Clock Status
      unsigned :status, 6
      # Reference Clock Type
      unsigned :type, 8
      # Local Clock Precision
      unsigned :precision, 16
      # Estimated Error
      unsigned :error_est, 32
      # Estimated Drift Rate
      unsigned :drift_est, 32
      # Reference Clock Identifier
      unsigned :ref_clock, 32
      # Reference Timestamp
      unsigned :ref_ts, 64
      # Originate Timestamp
      unsigned :orig_ts, 64
      # Receive Timestamp
      unsigned :rec_ts, 64
      # Transmit Timestamp
      unsigned :tr_ts, 64
      rest :payload
    end
  end
end
# vim: set ts=2 et sw=2:

