=begin

    Copyright The Resistance (C) 1995-2011

    Author: blass
    blass[at]sdf.lonestar.org

    Badass 0.1 alpha

    This file is part of Badass.

    Badass is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Badass is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Badass.  If not, see <http://www.gnu.org/licenses/>.

=end

module Racket
  module Misc
    # Return a number that is at most size bits long
    def Misc.randbits(size)
      bits = 0
      srand Time.now.usec
      0.upto(size-1) {
        bits <<= 1
        bits |= rand(2)
      }
      bits
    end
    
    # Return a byte that is at most size bytes long
    def Misc.randbytes(size)
      bytes = 0
      0.upto(size-1) {
        bytes <<= 8
        bytes |= randbits(8)
      }
      bytes
    end
    
    # Return a string that is at most size characters long
    def Misc.randstring(size)
      s = ""
      0.upto(size-1) {
        s += sprintf("%c", randbytes(1))
      }
      s
    end
  end
end
# vim: set ts=2 et sw=2:
